/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef __appbarwnd_h
#define __appbarwnd_h

/////////////////////////////////////////////////////////////////////////////
// CAppBarWnd frame

class CAppBarWnd : public CWnd
{
	DECLARE_DYNCREATE(CAppBarWnd)
protected:
	UINT m_uMaxPosition;
	void UpdateScrollRange();
	CFont m_cfont;
	APPBARDATA m_AppBar;    // The appbar structure
	BOOL m_bAppRegistered;
	BOOL m_bStarted;
	UINT m_uPosition;
	BOOL m_bScrolling;
	BOOL m_bVisible;
	UINT m_uSpeed;
	CString m_csText;

// Attributes
public:
	void UpdateScrollBar();
	void SetSpeed(UINT uSpeed);
	void StartScroll(BOOL bStart);
	void ShowText(UINT uStyle);
	void SetPosition(UINT uPos);
	void AddText(const CString& csText);
	void SetText(const CString& csText);
	CAppBarWnd();           // protected constructor used by dynamic creation
	virtual ~CAppBarWnd();
	void Start();
	BOOL RegisterAccessBar(BOOL fRegister);
    afx_msg LONG AppBarCallback(UINT uNotifyMsg,LPARAM lParam); 

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAppBarWnd)
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAppBarWnd)
	afx_msg void OnDestroy();
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnAppbarStop();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#define APPBAR_CALLBACK WM_USER+100
#define DEF_APPBAR_WIDTH    70
#define DEF_APPBAR_HEIGHT   25

CAppBarWnd* AfxGetAppBarWnd();


#endif

/////////////////////////////////////////////////////////////////////////////
