/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef _email_h
#define _email_h


#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "settings.h"

/////////////////////////////////////////////////////////////////////////////
// CEmailApp:
// See email.cpp for the implementation of this class
//

class CEmailApp : public CWinApp
{
 protected:
   CDialog* LogoDialog;

   BOOL  bHide;
   BOOL  bNoLogo;
   int m_nOldCmdShow;

 public:
	void ShowWebPage(CString strPage);
	CString GetVersion();
	CEmailApp();
	~CEmailApp();

   BOOL NoLogo() { return bNoLogo; };
   UINT uSettingsNb;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEmailApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

public:
   CNotifySettings* m_pConfig;

public:
    void CloseLogo();

// Implementation
public:
	//{{AFX_MSG(CEmailApp)
	afx_msg void OnAppAbout();
	afx_msg void OnHelpRegister();
	afx_msg void OnWWWHomepage();
	afx_msg void OnWWWFAQ();
	afx_msg void OnWWWDownload();
	afx_msg void OnHelpApplyReg();
	afx_msg void OnWWWRegister();
	afx_msg void OnHelpRegistration();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


CEmailApp* AfxGetEmailApp();
CNotifySettings* AfxGetConfig();


#define WM_UPDATE_THREAD_FINISHED 	WM_USER+1
#define WM_ASYNC_DNS 				WM_USER+2
#define WM_NOTIFY_ICON				WM_USER+3
#define WM_SET_MESSAGE  			WM_USER+4
#define WM_MAIL_DOWNLOAD  			WM_USER+5
#define WM_DELETE_THREAD_FINISHED   WM_USER+6
#define WM_VIEW_THREAD_FINISHED     WM_USER+7
#define WM_NOTIFY_PROGRESS		    WM_USER+8
#define WM_RASDIAL_MSG	   	        WM_USER+9


extern BOOL bWin4;

/////////////////////////////////////////////////////////////////////////////
#endif
