/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef _emaildoc_h
#define _emaildoc_h


#include "mail.h"

#ifndef WIN32
#include <afxcoll.h>
#else
#include <afxtempl.h>
#endif


class CEmailHint : public CObject
{
	DECLARE_DYNAMIC(CEmailHint)

 public:
	CEmailHint();
};


class CEmailDoc : public CDocument
{
protected:
	int mailtoview;
	int mailtodelete;
#ifdef WIN32
	CArray<CMail, CMail&> mail;
#else
    CObArray mail;
#endif
	int mailselected;


public:
	void EndThread();
#if defined(WIN95) || defined(WINNT35)
	CWinThread* wtPOPThread;
  UINT uTransferType;
#endif


protected: // create from serialization only
	CEmailDoc();
	DECLARE_DYNCREATE(CEmailDoc)


public:
	void DeleteMail();

// Attributes
protected:
  BOOL bFirstTransfer;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEmailDoc)
	public:
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEmailDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	void GetMail(UINT nMail,CString& strAuthor,CString& strSubject,CString& strDate,unsigned long& ulLong);
	unsigned GetMailNb() { return mail.GetSize(); };
	int GetMailSelected(); 

#ifndef LISTVIEW
	void ChangeSelectionNext(BOOL bNext);
	void ChangeSelectionTo(unsigned nRow);
#endif
    
	int GetMessages();
    int GetMessages2(BOOL bDisconnect,BOOL bReload);
    int MailDelete2(); 
    int MailView2(); 

    void MailDelete();
    void MailView();
    
    int find(unsigned long size,unsigned start);
    CString Substitute(CString cmdline);
    int Downloading();

    void Progress(UINT MessageCode,unsigned Progress);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CEmailDoc)
	afx_msg void OnMailDelete();
	afx_msg void OnMailView();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


CEmailDoc* AfxGetEmailDoc();

#endif

/////////////////////////////////////////////////////////////////////////////
