/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef _emailvh_h
#define _emailvw_h

#include "emaildoc.h"


#define AUTHOR_COL 0
#define AUTHOR_LEN 60
#define DATE_COL   (AUTHOR_COL + AUTHOR_LEN + 1)
#define DATE_LEN   40

#define SUBJECT_COL 0
#define SUBJECT_LEN 60
#define SIZE_COL (SUBJECT_COL + SUBJECT_LEN + 1)
#define SIZE_LEN 40

#define ROW_WIDTH   (SUBJECT_COL + SUBJECT_LEN)


class CEmailView : public CScrollView
{
public:
	CEmailView();

	DECLARE_DYNCREATE(CEmailView)

public:
  	int m_nRowWidth;            
	int m_nRowHeight;           
	int m_nPrevSelectedRow;     
	int m_nPrevRowCount;        

	CEmailDoc* GetDocument()
	{
		return (CEmailDoc*) m_pDocument;
	}
  
	void OnUpdate(CView* pSender, LPARAM lHint = 0L, CObject* pHint = NULL);
	void GetRowWidthHeight(CDC* pDC, int& nRowWidth, int& nRowHeight);
	int GetActiveRow();
	int GetRowCount();
	void OnDrawRow(CDC* pDC, int nRowNo, int y, BOOL bSelected);
	void ChangeSelectionNextRow(BOOL bNext);
	void ChangeSelectionToRow(int nRow);
	void UpdateRow(int nInvalidRow);    


// Implementation
protected:
	void OnInitialUpdate();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual void CalculateRowMetrics(CDC* pDC)
		{ GetRowWidthHeight(pDC, m_nRowWidth, m_nRowHeight); }
	virtual void UpdateScrollSizes();
	virtual CRect RowToWndRect(CDC* pDC, int nRow);
	virtual int RowToYPos(int nRow);
	virtual void RectLPtoRowRange(const CRect& rectLP,
			int& nFirstRow, int& nLastRow, BOOL bIncludePartiallyShownRows);
	virtual int LastViewableRow();
	virtual ~CEmailView() {}

protected:
//{{AFX_MSG(CEmailView)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
DECLARE_MESSAGE_MAP()
};


#endif
