/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



 #include "stdafx.h"
 #include "mail.h"


  CMail::CMail() : CObject()
  {
  }

  
  CMail::CMail(const CMail& cmail) : CObject()
  {
   Author = cmail.Author;
   Subject = cmail.Subject;
   Date = cmail.Date;
   Size = cmail.Size;
   Header = cmail.Header;
  }



  CMail::~CMail()
  {
   Author.Empty();
   Subject.Empty();
   Date.Empty();  
   Header.Empty();
  }


  void CMail::operator=(const CMail& cmail)
  {
   Author = cmail.Author;
   Subject = cmail.Subject;
   Date = cmail.Date;
   Header = cmail.Header;
   Size = cmail.Size;
  }


  void CMail::GetMail(CString& author,CString& subject,CString& date,unsigned long& size) const
  {
   author = Author;
   subject = Subject;
   date = Date;
   size = Size;
  }
  
  
  
  void CMail::SetMail(const CString author,const CString subject,const CString date, const CString header,const unsigned long size)
  {
   Author = author;
   Subject = subject;
   Date = date;
   Size = size;
   Header = header;
  }


  BOOL CMail::operator==(const CMail& cmail)
  {											 
   if ((Author==cmail.Author)
      &&(Subject==cmail.Subject)
	  &&(Date==cmail.Date))
	return TRUE;
   else
    return FALSE;
  }


void DestructElements(CMail* pMail, int nCount )
{
    for ( int i = 0; i < nCount; i++, pMail++ )
    {
		pMail->CMail::~CMail();
    }
}

void ConstructElements( CMail* pMail, int nCount )
{
    for ( int i = 0; i < nCount; i++, pMail++ )
    {
		// call CPerson default constructor directly
        pMail->CMail::CMail();
    }
}

CString CMail::GetAuthor()
{
 return Author;
}

CString CMail::GetSubject()
{
 return Subject;
}

CString CMail::GetDate()
{
 return Date;
}


CString CMail::GetHeader()
{
 return Header;
}


BOOL CMail::CompareHeader(CString csHeader,CString csPattern)
{
 // Get line with csHeader..
 // Get rest of line
 // Match the pattern...
 return TRUE;
}
