/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef _mail_h
#define _mail_h

#include <winsock.h>

class CMail : public CObject
{
 protected:
  CString Header;
  CString Author;
  CString Subject;
  CString Date; 
  unsigned long Size;

 public:
	CString GetDate();
	CString GetSubject();
	CString GetAuthor();
	CString GetHeader();
  CMail();
  CMail(const CMail& cmail);
  ~CMail();

  void GetMail(CString& author,CString& subject,CString& date,unsigned long& size) const;
  void SetMail(const CString author,const CString subject,const CString date,const CString header,const unsigned long size);
  unsigned long GetSize() { return Size; };
  void SetSize(unsigned long size) { Size = size; };

  BOOL CompareHeader(CString csHeader,CString csPattern);

  void operator=(const CMail& cmail);
  BOOL operator==(const CMail& cmail);
};


void ConstructElements(CMail* pMail, int nCount);
void DestructElements(CMail* pMail, int nCount);


#endif


