/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#ifndef _mainfrm_h
#define _mainfrm_h

#include "popclien.h"  

#ifndef WIN16
#include "ras.h"
#include "rasinit.h"
#endif             
             
#ifdef NEWTOOLTIP
#include "NotifyStatus.h"
#endif

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	BOOL m_bAsyncOk;
    CPOPClient* popclient;
	CMenu 	   popup;
	CMenu*	   sysmenu;
#ifdef NEWTOOLTIP
	CNotifyStatus* notifystatus;
#endif

    DWORD TickCount; 
	BOOL bInit;
	BOOL bAnimate;
    BOOL bDialUp;

	CString strStatus;

#if defined(WIN95) || defined(WINNT35)
    HRASCONN hrcRASHandle;
#endif

public:
	BOOL SetToolBar();
	CString strTray;
	CString	strTitle;

protected:
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)
	afx_msg LONG OnUpdateThreadFinished(UINT,LONG);
	afx_msg LONG OnDeleteThreadFinished(UINT,LONG);
	afx_msg LONG OnViewThreadFinished(UINT,LONG);
	afx_msg LONG OnAsyncDNS(UINT,LONG);
	afx_msg LONG OnNotifyIcon(UINT wparam,LONG lparam);
	afx_msg LONG OnDrawItem(UINT wparam,LONG lparam);
	afx_msg LONG OnUpdateMail(UINT,LONG);
	afx_msg LONG OnSetMessage(UINT wparam,LONG lparam);
	afx_msg LONG OnMailDownload(UINT wparam,LONG lparam);
	afx_msg LONG OnNotifyProgress(UINT,LONG);
	afx_msg void OnSysCommand(UINT wparam,LONG lparam);

	void SetAutoTransfer(BOOL autotransfer);
    void SetTransfering(BOOL transfering);
 	void UpdateTitleBar();
 
public:
	int iSafeGuard;
	BOOL DialUpIsConnected();
	
	void MailCheckEnd1(UINT uReason,UINT msgnb = 0);
	void MailCheckEnd2();

	void UpdateMail(); 
	CPOPClient* GetPOPClient() { return popclient; };
    void ReStartUpdateTimer();

#if defined(WIN95) || defined(WINNT35)
    afx_msg LONG OnRasDialEvent(UINT rasconnstate,LONG dwError);
#endif

#ifdef _DEBUG
    void MsgBox(const char* format,...);
	void MsgBox(UINT MessageCode,...);
#endif

	void ShowMailNumber(unsigned nbmail);

	void UpdateTray(UINT IconCode);
	void SetMessage(const char* message,UINT Type);
	void SetMessage(UINT MessageCode,UINT Type);
    void SetMessage(UINT MessageCode,UINT Type,int param1,int param2);
    void SetMessage(UINT MessageCode,UINT Type,int param1);
	// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


public:
    CToolBar   m_wndToolBar;

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	HANDLE      hAsyncDNS;
	UINT 		UpdateState;
	UINT 		ErrorState;
	UINT 		IdIcon;

#ifndef WIN32
    void SetMessageText(LPCTSTR lpszText);
#endif


public:
   int Downloading() { return UpdateState; };


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnMailCheckmail();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnStopUpdate();
	afx_msg void OnUpdateMailCheckmail(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMailOptions(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStopUpdate(CCmdUI* pCmdUI);
	afx_msg void OnUpdateClearMailWindow(CCmdUI* pCmdUI);
	afx_msg void OnClearMailWindow();
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnShowEmail();
	afx_msg void OnAutoTransfer();
	afx_msg void OnUpdateAppAbout(CCmdUI* pCmdUI);
	afx_msg void OnMailOptions2();
	afx_msg void OnMailReader();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAppExit();
	afx_msg void OnHelpIndex();
	afx_msg void OnUpdateMailFunction(CCmdUI* pCmdUI);
	afx_msg void OnHelp();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMove(int x, int y);
	//}}AFX_MSG

#ifndef WIN16
	afx_msg void OnViewStatusBar();
	afx_msg void OnViewToolbar();
#endif

#ifdef NEWTOOLTIP
	afx_msg void OnTestTooltip();
#endif

  public:
	afx_msg void OnMailDelete();
	afx_msg void OnMailView();

    DWORD DialUpConnect();
    DWORD DialUpDisconnect(UINT uReason,UINT msgnb = 0);
    void SendAsyncDNS();    


	DECLARE_MESSAGE_MAP()
};


CMainFrame* AfxGetMainFrame();


#define ID_UPDATE_MAIL_TIMER 1
#define ID_ANIMATE_TIMER 2
#define ID_STARTUP_TIMER 3
#define ID_SAFEGUARD     4


#define ST_IDLE    0
#define ST_DIALUP  1
#define ST_DNS     2
#define ST_MAIL    3
#define ST_CANCEL  10

#define DD_NORMAL 0
#define DD_ERROR  1
#define DD_CANCEL 2

/////////////////////////////////////////////////////////////////////////////

#endif
