/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef _popclient_h
#define _popclient_h


#include <winsock.h>
#include "popsock.h"

#include "mail.h"

class CPOPClient : public CObject
{
 protected:
  CPOPSocket* m_pSocket;

 public: 
  BOOL    bCanceling;


 public:
  CPOPClient(unsigned settingnb = 0);
  ~CPOPClient();


  int POPConnect();
  int POPGetSizes(unsigned long* sizes,unsigned messages);
  void POPDisconnect(int iMsgNb = 0);
  int  GetMessageHeader(unsigned int number,CMail& mail);
  BOOL DeleteMail(int mailnb);
  BOOL ViewMail(int mailnb,CString& strMail,unsigned long size);
  
  int StopUpdate();
  HANDLE SendAsyncDNS(HWND hwnd);


 protected:
  int POPConverse();
  CString POPReply(int &ErrorCode);
  CString POPReply(int &ErrorCode,unsigned long FullSize,unsigned long CurrentSize);

  void Log(CString message);
  void SocketError(UINT MessageCode,CString strReturn);
  void Progress(UINT MessageCode,unsigned Progress);

};


CPOPClient* AfxGetPOPClient();

#endif
