/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "ppopt2.h"
#include "popclien.h"
#include "idhindex.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPOpt2 property page

IMPLEMENT_DYNCREATE(CPPOpt2, CPropertyPage)


static DWORD Mapping[] = 
 {
	IDC_POPLOGIN, IDH_POPLOGIN,
	IDC_POPPASSWORD, IDH_POPPASSWORD,
	IDC_POPSERVER, IDH_POPSERVER,
	IDC_PASSWORD_SAVE, IDH_PASSWORD_SAVE,
	IDC_PASSWORD_ASK_ALWAYS,IDH_POPPASSWORD_ASK_ALWAYS,
	IDC_PASSWORD_ASKSTARTUP,IDH_POPPASSWORD_ASKSTARTUP
 };



CPPOpt2::CPPOpt2() : CPropertyPage(CPPOpt2::IDD)
{
	//{{AFX_DATA_INIT(CPPOpt2)
	m_poplogin = AfxGetConfig()->m_csPOPUsername;
	m_poppassword = AfxGetConfig()->m_csPOPPassword;
	m_popserver = AfxGetConfig()->m_csPOPServer;
	m_askalways = AfxGetConfig()->m_bPOPPasswordAskAlways;
	m_askstartup = AfxGetConfig()->m_bPOPPasswordAskStartup;
	m_save = AfxGetConfig()->m_bPOPPasswordSave;
	//}}AFX_DATA_INIT
}

CPPOpt2::~CPPOpt2()
{
}

void CPPOpt2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPOpt2)
	DDX_Text(pDX, IDC_POPLOGIN, m_poplogin);
	DDX_Text(pDX, IDC_POPPASSWORD, m_poppassword);
	DDX_Text(pDX, IDC_POPSERVER, m_popserver);
	DDX_Check(pDX, IDC_PASSWORD_ASK_ALWAYS, m_askalways);
	DDX_Check(pDX, IDC_PASSWORD_ASKSTARTUP, m_askstartup);
	DDX_Check(pDX, IDC_PASSWORD_SAVE, m_save);
	//}}AFX_DATA_MAP
}

void CPPOpt2::UpdatePOPClientFromPage()
{
  CPOPClient* popclient = AfxGetPOPClient();
  
  AfxGetConfig()->m_csPOPUsername = m_poplogin;
  AfxGetConfig()->m_csPOPPassword = m_poppassword;
  AfxGetConfig()->m_csPOPServer = m_popserver;
  AfxGetConfig()->m_bPOPPasswordSave = m_save;
  AfxGetConfig()->m_bPOPPasswordAskAlways = m_askalways;
  AfxGetConfig()->m_bPOPPasswordAskStartup = m_askstartup;
}



BEGIN_MESSAGE_MAP(CPPOpt2, CPropertyPage)
	//{{AFX_MSG_MAP(CPPOpt2)
	ON_EN_CHANGE(IDC_POPLOGIN, OnPageChanged)
	ON_EN_CHANGE(IDC_POPPASSWORD, OnPageChanged)
	ON_EN_CHANGE(IDC_POPSERVER, OnPageChanged)
	ON_BN_CLICKED(IDC_PASSWORD_ASK_ALWAYS, OnPageChanged)
	ON_BN_CLICKED(IDC_PASSWORD_ASKSTARTUP, OnPageChanged)
	ON_BN_CLICKED(IDC_PASSWORD_SAVE, OnPageChanged)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPPOpt2 message handlers

void CPPOpt2::OnPageChanged() 
{
 SetModified(TRUE);	
}

      
#ifdef WIN32      
LONG CPPOpt2::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPPOpt2::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}           
#endif
