/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "ppopt3.h"
#include "popclien.h"
#include "idhindex.h"

#include <mmsystem.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPOpt3 property page

IMPLEMENT_DYNCREATE(CPPOpt3, CPropertyPage)


static DWORD Mapping[] = 
 {
	IDC_EDIT_WAVE, IDH_WAVEFILENAME,
	IDC_SPEAKER_ON_NEW_MAIL, IDH_SPEAKERBEEP,
	IDC_WAV_ON_NEW_MAIL, IDH_WAVE,
    IDC_MESSAGE_BOX, IDH_MESSAGEBOX,
	IDC_BROWSE_WAVE, IDH_BROWSE
 };



CPPOpt3::CPPOpt3() : CPropertyPage(CPPOpt3::IDD)
{
	CPOPClient* popclient = AfxGetPOPClient();
	//{{AFX_DATA_INIT(CPPOpt3)
	m_speaker_beep = AfxGetConfig()->m_bNOTIFYSpeaker;
	m_wave = AfxGetConfig()->m_bNOTIFYWav;
	m_edit_wave = AfxGetConfig()->m_csNOTIFYWave;
	m_msg_box = AfxGetConfig()->m_bNOTIFYMsgBox;
	//}}AFX_DATA_INIT
}

CPPOpt3::~CPPOpt3()
{
}

void CPPOpt3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPOpt3)
	DDX_Text(pDX, IDC_EDIT_WAVE, m_edit_wave);
	DDX_Check(pDX, IDC_SPEAKER_ON_NEW_MAIL, m_speaker_beep);
	DDX_Check(pDX, IDC_WAV_ON_NEW_MAIL, m_wave);
	DDX_Check(pDX, IDC_MESSAGE_BOX, m_msg_box);
	//}}AFX_DATA_MAP
}


void CPPOpt3::UpdatePOPClientFromPage()
{
  AfxGetConfig()->m_bNOTIFYSpeaker = m_speaker_beep;
  AfxGetConfig()->m_bNOTIFYWav = m_wave;
  AfxGetConfig()->m_csNOTIFYWave = m_edit_wave;
  AfxGetConfig()->m_bNOTIFYMsgBox = m_msg_box;
}


BEGIN_MESSAGE_MAP(CPPOpt3, CPropertyPage)
	//{{AFX_MSG_MAP(CPPOpt3)
	ON_BN_CLICKED(IDC_BROWSE_WAVE, OnBrowseWave)
	ON_EN_CHANGE(IDC_EDIT_WAVE, OnPageChanged)
	ON_BN_CLICKED(IDC_MESSAGE_BOX, OnPageChanged)
	ON_BN_CLICKED(IDC_SPEAKER_ON_NEW_MAIL, OnPageChanged)
	ON_BN_CLICKED(IDC_WAV_ON_NEW_MAIL, OnPageChanged)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPPOpt3 message handlers

void CPPOpt3::OnBrowseWave() 
{
 UpdateData(TRUE);
 OPENFILENAME ofn;
 memset(&ofn, 0, sizeof(ofn));

 ofn.lStructSize=sizeof(ofn);
 ofn.hwndOwner = GetSafeHwnd();
 ofn.lpstrFilter = "Wave Files\0*.wav";
 ofn.lpstrCustomFilter = NULL;
 ofn.nFilterIndex = 0;
 ofn.lpstrFile = new char[255];
 strncpy(ofn.lpstrFile,"",255);
 ofn.nMaxFile = 255;
 ofn.lpstrFileTitle = "Choose a new wave file to play";
 ofn.lpstrInitialDir = NULL;
 ofn.Flags = OFN_HIDEREADONLY;
 #ifdef WIN95
 ofn.Flags |= OFN_EXPLORER;
 #endif

 if (GetOpenFileName(&ofn))
  { 
   m_edit_wave = ofn.lpstrFile;
   SetModified(TRUE);
   UpdateData(FALSE);
  }

 delete[] ofn.lpstrFile;
}


void CPPOpt3::OnPageChanged() 
{
 SetModified(TRUE);	
}     


#ifdef WIN32
LONG CPPOpt3::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPPOpt3::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}
#endif            
            
void CPPOpt3::OnPlay() 
{
  UpdateData(TRUE);
  if (!sndPlaySound(m_edit_wave,SND_SYNC))
   AfxMessageBox(IDS_ERROR_SOUND);
}
