/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#ifndef _psoption_h
#define _psoption_h


#include "ppopt1.h"
#include "ppopt2.h"
#include "ppopt3.h"
#include "ppopt4.h"
#include "ppopt5.h"
#include "ppopt6.h"


/////////////////////////////////////////////////////////////////////////////
// CPSOptions

class CPSOptions : public CPropertySheet
{
	DECLARE_DYNAMIC(CPSOptions)

// Construction
public:
	CPSOptions(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CPSOptions(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:
	CPPOpt1 ppopt1;
	CPPOpt2 ppopt2;
	CPPOpt3 ppopt3;
	CPPOpt4 ppopt4;
	CPPOpt5 ppopt5;
#if defined(WIN95) || defined(WINNT35)
	CPPOpt6 ppopt6;
#endif


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPSOptions)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual void OnApply();
	virtual void OnOk();
	virtual ~CPSOptions();

	// Generated message map functions
protected:
	//{{AFX_MSG(CPSOptions)
	afx_msg void OnHelpButton();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	afx_msg LONG OnHelp(UINT wParam,LONG lParam);
	afx_msg LONG OnContextMenu(UINT wParam,LONG lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
