/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "resource.h"
#include "email.h"
#include "settings.h"

#include "pwdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_PASS 250
/////////////////////////////////////////////////////////////////////////////
// CPasswordDlg dialog


CPasswordDlg::CPasswordDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPasswordDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPasswordDlg)
	m_strPassword = _T("");
	//}}AFX_DATA_INIT
}

void CPasswordDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPasswordDlg)
	DDX_Text(pDX, CG_IDC_PASSWORD, m_strPassword);
	DDV_MaxChars(pDX, m_strPassword, MAX_PASS);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPasswordDlg, CDialog)
	//{{AFX_MSG_MAP(CPasswordDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPasswordDlg Helper routines

BOOL CPasswordDlg::CheckPassword()
{
	CPasswordDlg dlg;
	if (dlg.DoModal() != IDOK)
		return FALSE;
	else
		return TRUE;
}


void CPasswordDlg::OnOK() 
{
	UpdateData(TRUE);
	AfxGetConfig()->m_csPOPPassword = m_strPassword;
	AfxGetConfig()->SaveProfileString();
	CDialog::OnOK();
}


void CPasswordDlg::OnCancel() 
{
	UpdateData(TRUE);
	AfxGetConfig()->m_csPOPPassword = _T("");
	AfxGetConfig()->SaveProfileString();
	CDialog::OnCancel();
}

BOOL CPasswordDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetWindowText(AfxGetAppName());
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

