/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "ras.h"
#include "rasinit.h"


PFNRasDial					lpfnRasDial;
PFNRasEnumConnections		lpfnRasEnumConnections;
PFNRasEnumEntries			lpfnRasEnumEntries;
PFNRasGetConnectStatus		lpfnRasGetConnectStatus;
PFNRasGetErrorString		lpfnRasGetErrorString;
PFNRasHangUp				lpfnRasHangUp;
PFNRasCreatePhonebookEntry	lpfnRasCreatePhonebookEntry;
PFNRasEditPhonebookEntry	lpfnRasEditPhonebookEntry;

HINSTANCE hLibrary;


int InitRAS()
{

  if ((hLibrary = LoadLibrary(RASDLL)) < (HANDLE)32)
    return(ERR_LOAD_LIB);

 
  if ((lpfnRasDial = (PFNRasDial)GetProcAddress(hLibrary,SZ_RASDIAL)) == NULL)
    return(ERR_LOAD_FUNC);
  if ((lpfnRasEnumConnections = (PFNRasEnumConnections)GetProcAddress(hLibrary,SZ_RASENUMCONNECTIONS)) == NULL)
    return(ERR_LOAD_FUNC);
  if ((lpfnRasEnumEntries = (PFNRasEnumEntries)GetProcAddress(hLibrary,SZ_RASENUMENTRIES)) == NULL)
    return(ERR_LOAD_FUNC);
  if ((lpfnRasGetConnectStatus = (PFNRasGetConnectStatus)GetProcAddress(hLibrary,SZ_RASGETCONNECTSTATUS)) == NULL)
    return(ERR_LOAD_FUNC);
  if ((lpfnRasGetErrorString = (PFNRasGetErrorString)GetProcAddress(hLibrary,SZ_RASGETERRORSTRING)) == NULL)
    return(ERR_LOAD_FUNC);
  if ((lpfnRasHangUp = (PFNRasHangUp)GetProcAddress(hLibrary,SZ_RASHANGUP)) == NULL)
    return(ERR_LOAD_FUNC);
  if ((lpfnRasCreatePhonebookEntry = (PFNRasCreatePhonebookEntry)GetProcAddress(hLibrary,SZ_RASCREATEPHONEBOOKENTRY)) == NULL)
    return(ERR_LOAD_FUNC);
if ((lpfnRasEditPhonebookEntry = (PFNRasEditPhonebookEntry)GetProcAddress(hLibrary,SZ_RASEDITPHONEBOOKENTRY)) == NULL)
    return(ERR_LOAD_FUNC);


  return(0);
}


int ExitRAS()
{
  lpfnRasDial = NULL;
  lpfnRasEnumConnections = NULL;
  lpfnRasEnumEntries = NULL;
  lpfnRasGetConnectStatus = NULL;
  lpfnRasGetErrorString = NULL;
  lpfnRasHangUp = NULL;
  lpfnRasCreatePhonebookEntry = NULL;
  lpfnRasEditPhonebookEntry = NULL;

  if (hLibrary>=(HANDLE)32)
   FreeLibrary(hLibrary);

  return(0);
}
