/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#include "stdafx.h"
#include "settings.h"

#ifndef WIN16
#include <winreg.h>
#endif             

#ifndef FREEWARE             
#if defined(WIN95) || defined(WINNT35)
extern "C" int __stdcall CheckSignature(char*,char*,char*,char*,char*);
#endif
#endif

extern "C" char* EncryptMessage(char* cInMessage,char* cOutMessage,char* cKey);
extern "C" char* DecryptMessage(char* cInMessage,char* cOutMessage,char* cKey);


CNotifySettings::CNotifySettings(CWinApp* pApp,UINT uSettingsNb)
{
 m_pApp = pApp;

 char buffer[20];
 if (uSettingsNb!=0)
  sprintf(buffer,"Settings_%u",uSettingsNb);
 else
  sprintf(buffer,"Settings");
 m_csSettingsName = buffer;
 
 m_csPOP	= m_csSettingsName + "\\POP";
 m_csNOTIFY = m_csSettingsName + "\\Notify";
 m_csCHECK	= m_csSettingsName + "\\Checking";
 m_csUI		= m_csSettingsName + "\\User Interface";
 m_csWINDOW = m_csSettingsName + "\\Window";
 m_csRA		= m_csSettingsName + "\\Remote Access";
 m_csLOG	= m_csSettingsName + "\\Logging";
 m_csREGISTER = "Registration";
	

 LoadProfileString();
}


CNotifySettings::~CNotifySettings()
{
 SaveProfileString();
}


void CNotifySettings::SaveProfileString()
{
 m_pApp->WriteProfileString(m_csPOP,"Server Name",m_csPOPServer);
 m_pApp->WriteProfileString(m_csPOP,"User Name",m_csPOPUsername);
 m_pApp->WriteProfileInt(m_csPOP,"Save Password",m_bPOPPasswordSave);
 m_pApp->WriteProfileInt(m_csPOP,"Always Ask Password",m_bPOPPasswordAskAlways);
 m_pApp->WriteProfileInt(m_csPOP,"Ask Password at Startup",m_bPOPPasswordAskStartup);
   
 m_pApp->WriteProfileString(m_csNOTIFY,"Wave Filename",m_csNOTIFYWave);
 m_pApp->WriteProfileString(m_csNOTIFY,"External Mail Reader",m_csNOTIFYMailReader);
 m_pApp->WriteProfileString(m_csNOTIFY,"Spawn Program Filename",m_csNOTIFYSpawnProgram);
 m_pApp->WriteProfileInt(m_csNOTIFY,"Speaker Beep",m_bNOTIFYSpeaker);
 m_pApp->WriteProfileInt(m_csNOTIFY,"Play Wave",m_bNOTIFYWav);
 m_pApp->WriteProfileInt(m_csNOTIFY,"Message Box",m_bNOTIFYMsgBox);
 m_pApp->WriteProfileInt(m_csNOTIFY,"Spawn Program",m_bNOTIFYSpawn);
 m_pApp->WriteProfileInt(m_csNOTIFY,"Spawn Not On First Transfer",m_bNOTIFYSpawnNotFirst);
 
 
 m_pApp->WriteProfileString(m_csRA,"Service Name",m_csRAService);
 m_pApp->WriteProfileString(m_csRA,"Login",m_csRALogin);
 m_pApp->WriteProfileString(m_csRA,"Password",Encrypt(m_csRAPassword));
 m_pApp->WriteProfileInt(m_csRA,"Monitor",m_bRAMonitor);
 m_pApp->WriteProfileInt(m_csRA,"Ask Disconnect",m_bRAAskDisconnect);
 m_pApp->WriteProfileInt(m_csRA,"Dial-In",m_bRADialIn);
 m_pApp->WriteProfileInt(m_csRA,"Dial-Up Interval",m_uRATime);
 
 
 m_pApp->WriteProfileInt(m_csCHECK,"Auto Notify",m_bCHECKAutoNotify);
 m_pApp->WriteProfileInt(m_csCHECK,"Update Interval",m_uCHECKTime);
 m_pApp->WriteProfileInt(m_csCHECK,"Check On Startup",m_bCHECKOnStartup);

 m_pApp->WriteProfileString(m_csLOG,"Filename",m_csLOGFilename);
 m_pApp->WriteProfileInt(m_csLOG,"Logging",m_bLOGLogging);
 m_pApp->WriteProfileInt(m_csLOG,"Verbose",m_bLOGVerbose);
 
 m_pApp->WriteProfileInt(m_csUI,"Message Box On Errors",m_bUIMsgBoxOnError);
 m_pApp->WriteProfileInt(m_csUI,"Start Hidden",m_bUIStartHidden);
 m_pApp->WriteProfileInt(m_csUI,"Toolbar",m_bUIToolbar);
 m_pApp->WriteProfileInt(m_csUI,"Statusbar",m_bUIStatusbar);
 m_pApp->WriteProfileString(m_csUI,"ListView Position",m_csUIListViewPos);
 m_pApp->WriteProfileString(m_csUI,"ListView Font",m_csUIListViewFont);
 m_pApp->WriteProfileString(m_csUI,"Window Position",m_csUIMainWindowPos);


 m_pApp->WriteProfileString(m_csREGISTER,"Name",m_csREGISTERName);
 m_pApp->WriteProfileString(m_csREGISTER,"Email",m_csREGISTEREmail);
 m_pApp->WriteProfileString(m_csREGISTER,"File",m_csREGISTERFile);

 CString pass;
 if (m_bPOPPasswordSave) 
  {
   pass = m_csPOPPassword;
  }
 else
  {
   pass = "";
  }

 m_pApp->WriteProfileString(m_csPOP,"Password",Encrypt(pass));
}

 
void CNotifySettings::LoadProfileString()
{
 m_csPOPServer = m_pApp->GetProfileString(m_csPOP,"Server Name","");
 m_csPOPUsername = m_pApp->GetProfileString(m_csPOP,"User Name","");
 m_csPOPPassword = Decrypt(AfxGetApp()->GetProfileString(m_csPOP,"Password",""));
 m_bPOPPasswordSave = m_pApp->GetProfileInt(m_csPOP,"Save Password",1);
 m_bPOPPasswordAskAlways = m_pApp->GetProfileInt(m_csPOP,"Always Ask Password",0);
 m_bPOPPasswordAskStartup = m_pApp->GetProfileInt(m_csPOP,"Ask Password at Startup",0);
 
  
 m_csNOTIFYWave = m_pApp->GetProfileString(m_csNOTIFY,"Wave Filename","newmail.wav");
 m_csNOTIFYMailReader = m_pApp->GetProfileString(m_csNOTIFY,"External Mail Reader","EXCHNG32.EXE /i");
 m_csNOTIFYSpawnProgram = m_pApp->GetProfileString(m_csNOTIFY,"Spawn Program Filename","EXCHNG32.EXE /i");
 
 m_bNOTIFYSpeaker = m_pApp->GetProfileInt(m_csNOTIFY,"Speaker Beep",0);
 m_bNOTIFYWav = m_pApp->GetProfileInt(m_csNOTIFY,"Play Wave",1);
 m_bNOTIFYMsgBox = m_pApp->GetProfileInt(m_csNOTIFY,"Message Box",0);
 m_bNOTIFYSpawn = m_pApp->GetProfileInt(m_csNOTIFY,"Spawn Program",0);
 m_bNOTIFYSpawnNotFirst = m_pApp->GetProfileInt(m_csNOTIFY,"Spawn Not On First Transfer",0);
 
 
 m_csRAService = m_pApp->GetProfileString(m_csRA,"Service Name","");
 m_csRALogin = m_pApp->GetProfileString(m_csRA,"Login","");
 m_csRAPassword = Decrypt(m_pApp->GetProfileString(m_csRA,"Password",""));
 m_bRAMonitor = m_pApp->GetProfileInt(m_csRA,"Monitor",0);
 m_bRAAskDisconnect = m_pApp->GetProfileInt(m_csRA,"Ask Disconnect",0);
 m_bRADialIn = m_pApp->GetProfileInt(m_csRA,"Dial-In",0);
 m_uRATime = m_pApp->GetProfileInt(m_csRA,"Dial-Up Interval",60);
 
 
 m_bCHECKAutoNotify = m_pApp->GetProfileInt(m_csCHECK,"Auto Notify",0);
 m_uCHECKTime = m_pApp->GetProfileInt(m_csCHECK,"Update Interval",60);
 m_bCHECKOnStartup = m_pApp->GetProfileInt(m_csCHECK,"Check On Startup",0);

 m_csLOGFilename = m_pApp->GetProfileString(m_csLOG,"Filename","request.log");
 m_bLOGLogging = m_pApp->GetProfileInt(m_csLOG,"Logging",0);
 m_bLOGVerbose = m_pApp->GetProfileInt(m_csLOG,"Verbose",0);
 
 m_bUIMsgBoxOnError = m_pApp->GetProfileInt(m_csUI,"Message Box On Errors",1);
 m_bUIStartHidden = m_pApp->GetProfileInt(m_csUI,"Start Hidden",0);
 m_bUIToolbar = m_pApp->GetProfileInt(m_csUI,"Toolbar",1);
 m_bUIStatusbar = m_pApp->GetProfileInt(m_csUI,"Statusbar",1);
 m_csUIListViewPos = m_pApp->GetProfileString(m_csUI,"ListView Position","116,77,205,81");
 m_csUIListViewFont = m_pApp->GetProfileString(m_csUI,"ListView Font","Arial,-12,0,400,0");
 m_csUIMainWindowPos = m_pApp->GetProfileString(m_csUI,"Window Position","");

 m_csREGISTERName = m_pApp->GetProfileString(m_csREGISTER,"Name","");
 m_csREGISTEREmail = m_pApp->GetProfileString(m_csREGISTER,"Email","");
 m_csREGISTERFile = m_pApp->GetProfileString(m_csREGISTER,"File","reg.dat");
}




CString CNotifySettings::Encrypt(CString pass)
{
 char cOutMessage[256];
 if (pass=="")
  return "";
 else
 { 
  EncryptMessage(pass.GetBuffer(0),cOutMessage,"Did you pay your registration fee ?");
  return CString(cOutMessage);
 }
}

CString CNotifySettings::Decrypt(CString pass)
{
 if (pass=="")
  return "";
 else
  {
   char cOutMessage[32];
   DecryptMessage(pass.GetBuffer(0),cOutMessage,"Did you pay your registration fee ?");
   return CString(cOutMessage);
  }
}

