/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#ifndef __SETTINGS_H
#define __SETTINGS_H




class CNotifySettings : public CObject
{
	public:
		CWinApp* m_pApp;
		
		// Set of Settings
		CString m_csSettingsName;
		CString m_csPOP;
		CString m_csCHECK;
		CString m_csLOG;
		CString m_csNOTIFY;
		CString m_csUI;
		CString m_csRA;
		CString m_csWINDOW;
		CString m_csREGISTER;
		
		CString m_csPOPServer;
		CString m_csPOPUsername;
	    CString m_csPOPPassword;
		BOOL m_bPOPPasswordSave;
		BOOL m_bPOPPasswordAskStartup;
		BOOL m_bPOPPasswordAskAlways;

		UINT	m_uCHECKTime;
	    BOOL    m_bCHECKAutoNotify;
	    BOOL    m_bCHECKOnStartup;
	
		BOOL    m_bUIMsgBoxOnError;
		BOOL    m_bUIStartHidden;
		BOOL    m_bUIToolbar;
		BOOL    m_bUIStatusbar;
		CString m_csUIListViewPos;
		CString m_csUIListViewFont;
		CString m_csUIMainWindowPos;


		CString m_csNOTIFYWave;
	    CString m_csNOTIFYMailReader;
	    CString m_csNOTIFYSpawnProgram;
		BOOL    m_bNOTIFYMsgBox;
	    BOOL 	m_bNOTIFYSpawn;		
		BOOL 	m_bNOTIFYSpawnNotFirst;		
	 	BOOL	m_bNOTIFYSpeaker;		
	    BOOL    m_bNOTIFYWav;
	    
		CString m_csLOGFilename;
		BOOL    m_bLOGLogging;
	    BOOL    m_bLOGVerbose;
		    
		CString m_csRAService;
	    CString m_csRALogin;
	    CString m_csRAPassword;
		BOOL	m_bRADialIn;
		BOOL	m_bRAAskDisconnect;
		BOOL	m_bRAMonitor;
		UINT	m_uRATime;

		CString m_csREGISTERName;
		CString m_csREGISTEREmail;
		CString m_csREGISTERFile;
		
  public:
	CNotifySettings(CWinApp* pApp,UINT uSettingsNb);
	~CNotifySettings();

	void SaveProfileString();
    void LoadProfileString();

  protected:
    CString Encrypt(CString pass);
    CString Decrypt(CString pass);
    
};


#endif   

